| LUFA Library 140302 |

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Data Structures | Enumerations | Functions
Printer Class Host Mode Driver
Printer Class Driver

## Data Structures
struct | USB_ClassInfo_PRNT_Host_t
| Printer Class Host Mode Configuration and State Structure. More...

## Enumerations
enum | PRNT_Host_EnumerationFailure_ErrorCodes_t { PRNT_ENUMERROR_NoError = 0, PRNT_ENUMERROR_InvalidConfigDescriptor = 1, PRNT_ENUMERROR_NoCompatibleInterfaceFound = 2, PRNT_ENUMERROR_PipeConfigurationFailed = 3 }

## Functions
uint16_t | PRNT_Host_BytesReceived (USB_ClassInfo_PRNT_Host_t *const PRNTInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
uint8_t | PRNT_Host_ConfigurePipes (USB_ClassInfo_PRNT_Host_t *const PRNTInterfaceInfo, uint16_t ConfigDescriptorSize, void *ConfigDescriptorData) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(3)
uint8_t | PRNT_Host_Flush (USB_ClassInfo_PRNT_Host_t *const PRNTInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
uint8_t | PRNT_Host_GetDeviceID (USB_ClassInfo_PRNT_Host_t *const PRNTInterfaceInfo, char *const DeviceIDString, const uint16_t BufferSize) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2)
uint8_t | PRNT_Host_GetPortStatus (USB_ClassInfo_PRNT_Host_t *const PRNTInterfaceInfo, uint8_t *const PortStatus) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2)
int16_t | PRNT_Host_ReceiveByte (USB_ClassInfo_PRNT_Host_t *const PRNTInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
uint8_t | PRNT_Host_SendByte (USB_ClassInfo_PRNT_Host_t *const PRNTInterfaceInfo, const uint8_t Data) ATTR_NON_NULL_PTR_ARG(1)
uint8_t | PRNT_Host_SendData (USB_ClassInfo_PRNT_Host_t *const PRNTInterfaceInfo, const void *Buffer, const uint16_t Length) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2)
uint8_t | PRNT_Host_SendString (USB_ClassInfo_PRNT_Host_t *const PRNTInterfaceInfo, const char *const String) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2)
uint8_t | PRNT_Host_SetBidirectionalMode (USB_ClassInfo_PRNT_Host_t *const PRNTInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
uint8_t | PRNT_Host_SoftReset (USB_ClassInfo_PRNT_Host_t *const PRNTInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
void | PRNT_Host_USBTask (USB_ClassInfo_PRNT_Host_t *const PRNTInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)

## Detailed Description

# Module Source Dependencies

The following files must be built with any user project that uses this module:

- LUFA/Drivers/USB/Class/Host/PrinterClassHost.c (Makefile source module name: LUFA_SRC_USBCLASS)

# Module Description

Host Mode USB Class driver framework interface, for the Printer USB Class driver.

## Enumeration Type Documentation

enum PRNT_Host_EnumerationFailure_ErrorCodes_t

Enum for the possible error codes returned by the PRNT_Host_ConfigurePipes() function.

Enumerator
PRNT_ENUMERROR_NoError | Configuration Descriptor was processed successfully.
PRNT_ENUMERROR_InvalidConfigDescriptor | The device returned an invalid Configuration Descriptor.
PRNT_ENUMERROR_NoCompatibleInterfaceFound | A compatible Printer interface was not found in the device's Configuration Descriptor.
PRNT_ENUMERROR_PipeConfigurationFailed | One or more pipes for the specified interface could not be configured correctly.

## Function Documentation

uint16_t PRNT_Host_BytesReceived | ( | USB_ClassInfo_PRNT_Host_t *const | PRNTInterfaceInfo | ) |

Determines the number of bytes received by the printer interface from the device, waiting to be read. This indicates the number of bytes in the IN pipe bank only, and thus the number of calls to PRNT_Host_ReceiveByte() which are guaranteed to succeed immediately. If multiple bytes are to be received, they should be buffered by the user application, as the pipe bank will not be released back to the USB controller until all bytes are read.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class host configuration and state.

Returns
  Total number of buffered bytes received from the device.

uint8_t PRNT_Host_ConfigurePipes | ( | USB_ClassInfo_PRNT_Host_t *const | PRNTInterfaceInfo,
|  | uint16_t | ConfigDescriptorSize,
|  | void * | ConfigDescriptorData
| ) |  |

Host interface configuration routine, to configure a given Printer host interface instance using the Configuration Descriptor read from an attached USB device. This function automatically updates the given Printer instance's state values and configures the pipes required to communicate with the interface if it is found within the device. This should be called once after the stack has enumerated the attached device, while the host state machine is in the Addressed state.

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class host configuration and state.
  [in] | ConfigDescriptorSize | Length of the attached device's Configuration Descriptor.
  [in] | ConfigDescriptorData | Pointer to a buffer containing the attached device's Configuration Descriptor.

Returns
  A value from the PRNT_Host_EnumerationFailure_ErrorCodes_t enum.

uint8_t PRNT_Host_Flush | ( | USB_ClassInfo_PRNT_Host_t *const | PRNTInterfaceInfo | ) |

Flushes any data waiting to be sent, ensuring that the send buffer is cleared.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class host configuration and state.

Returns
  A value from the Pipe_WaitUntilReady_ErrorCodes_t enum.

uint8_t PRNT_Host_GetDeviceID | ( | USB_ClassInfo_PRNT_Host_t *const | PRNTInterfaceInfo,
|  | char *const | DeviceIDString,
|  | const uint16_t | BufferSize
| ) |  |

Retrieves the attached printer device's ID string, formatted according to IEEE 1284. This string is sent as a Unicode string from the device and is automatically converted to an ASCII encoded C string by this function, thus the maximum reportable string length is two less than the size given (to accommodate the Unicode string length bytes which are removed).

This string, when supported, contains the model, manufacturer and acceptable printer languages for the attached device.

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class host configuration and state.
  [out] | DeviceIDString | Pointer to a buffer where the Device ID string should be stored, in ASCII format.
  [in] | BufferSize | Size in bytes of the buffer allocated for the Device ID string.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum.

uint8_t PRNT_Host_GetPortStatus | ( | USB_ClassInfo_PRNT_Host_t *const | PRNTInterfaceInfo,
|  | uint8_t *const | PortStatus
| ) |  |

Retrieves the status of the virtual Printer port's inbound status lines. The result can then be masked against the `PRNT_PORTSTATUS_*` macros to determine the printer port's status.

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class host configuration and state.
  [out] | PortStatus | Location where the retrieved port status should be stored.

Returns
  A value from the USB_Host_SendControlErrorCodes_t enum.

int16_t PRNT_Host_ReceiveByte | ( | USB_ClassInfo_PRNT_Host_t *const | PRNTInterfaceInfo | ) |

Reads a byte of data from the device. If no data is waiting to be read of if a USB device is not connected, the function returns a negative value. The PRNT_Host_BytesReceived() function may be queried in advance to determine how many bytes are currently buffered in the Printer interface's data receive pipe.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class host configuration and state.

Returns
  Next received byte from the device, or a negative value if no data received.

uint8_t PRNT_Host_SendByte | ( | USB_ClassInfo_PRNT_Host_t *const | PRNTInterfaceInfo,
|  | const uint8_t | Data
| ) |  |

Sends a given byte to the attached USB device, if connected. If a device is not connected when the function is called, the byte is discarded. Bytes will be queued for transmission to the device until either the pipe bank becomes full, or the PRNT_Host_Flush() function is called to flush the pending data to the host. This allows for multiple bytes to be packed into a single pipe packet, increasing data throughput.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class host configuration and state.
  [in] | Data | Byte of data to send to the device.

Returns
  A value from the Pipe_WaitUntilReady_ErrorCodes_t enum.

uint8_t PRNT_Host_SendData | ( | USB_ClassInfo_PRNT_Host_t *const | PRNTInterfaceInfo,
|  | const void * | Buffer,
|  | const uint16_t | Length
| ) |  |

Sends the given raw data stream to the attached printer's input endpoint. This should contain commands that the printer is able to understand - for example, PCL data. Not all printers accept all printer languages; see PRNT_Host_GetDeviceID() for details on determining acceptable languages for an attached printer.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class host configuration and state.
  [in] | Buffer | Pointer to a buffer containing the raw command stream to send to the printer.
  [in] | Length | Size in bytes of the command stream to be sent.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum.

uint8_t PRNT_Host_SendString | ( | USB_ClassInfo_PRNT_Host_t *const | PRNTInterfaceInfo,
|  | const char *const | String
| ) |  |

Sends the given null terminated string to the attached printer's input endpoint.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class host configuration and state.
  [in] | String | Pointer to a null terminated string to send.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum.

uint8_t PRNT_Host_SetBidirectionalMode | ( | USB_ClassInfo_PRNT_Host_t *const | PRNTInterfaceInfo | ) |

Configures the printer to enable Bidirectional mode, if it is not already in this mode. This should be called once the connected device's configuration has been set, to ensure the printer is ready to accept commands.

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class host configuration and state.

Returns
  A value from the USB_Host_SendControlErrorCodes_t enum.

uint8_t PRNT_Host_SoftReset | ( | USB_ClassInfo_PRNT_Host_t *const | PRNTInterfaceInfo | ) |

Soft-resets the attached printer, readying it for new commands.

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class host configuration and state.

Returns
  A value from the USB_Host_SendControlErrorCodes_t enum.

void PRNT_Host_USBTask | ( | USB_ClassInfo_PRNT_Host_t *const | PRNTInterfaceInfo | ) |

General management task for a given Printer host class interface, required for the correct operation of the interface. This should be called frequently in the main program loop, before the master USB management task USB_USBTask().

Parameters

  [in,out] | PRNTInterfaceInfo | Pointer to a structure containing a Printer Class host configuration and state.